// Generated by CoffeeScript 1.6.3
var fs, middleware;

fs = require('fs');

middleware = function(opts) {
  var bebopJs, injectJs, serveStatic, _middleware;
  if (opts == null) {
    opts = {};
  }
  bebopJs = "<script src=\"/bebop-client/bebop.js\"></script>\n<script>\n  var bebop = new Bebop(" + (JSON.stringify(opts)) + ");\n  bebop.connect()\n</script>";
  injectJs = function(res) {
    var appendScript, end, setHeader;
    appendScript = false;
    end = res.end;
    setHeader = res.setHeader;
    res.setHeader = function(name, value) {
      if (/text\/html/i.test(value)) {
        appendScript = true;
      } else if (name === 'Content-Length' && appendScript) {
        value = parseInt(value, 10) + bebopJs.length;
      }
      return setHeader.call(res, name, value);
    };
    return res.end = function(chunk, encoding) {
      if (appendScript) {
        res.write(bebopJs, encoding);
      }
      return end.call(res, chunk, encoding);
    };
  };
  serveStatic = function(req, res) {
    var headers;
    switch (req.url) {
      case '/bebop-client/bebop.js':
        headers = {
          'Content-Type': 'application/javascript',
          'SourceMap': 'bebop.map',
          'X-SourceMap': 'bebop.map'
        };
        break;
      case '/bebop-client/bebop.map':
        headers = {
          'Content-Type': 'application/json'
        };
        break;
      case '/bebop-client/bebop.coffee':
        headers = {
          'Content-Type': 'application/coffeescript'
        };
    }
    res.writeHead(200, headers);
    return fs.createReadStream(__dirname + '/..' + req.url).pipe(res);
  };
  _middleware = function(req, res, next) {
    if (/^\/bebop-client/.test(req.url)) {
      return serveStatic(req, res);
    }
    injectJs(res);
    return next();
  };
  return function bebop(req, res, next) { return _middleware(req, res, next); };;
};

module.exports = function(opts) {
  var inject, injectConnectApp, injectHttpServer, _middleware;
  if (opts == null) {
    opts = {};
  }
  if (typeof opts === 'function') {
    opts = {
      attach: opts
    };
  }
  _middleware = middleware(opts);
  injectConnectApp = function(app) {
    app.stack.splice(2, 0, {
      route: '',
      handle: _middleware
    });
    return app;
  };
  injectHttpServer = function(server) {
    var app;
    app = server.listeners('request')[0];
    if (typeof app === 'function') {
      server.removeListener('request', app);
    }
    return server.on('request', function(req, res) {
      return _middleware(req, res, function() {
        return app(req, res);
      });
    });
  };
  inject = function(app) {
    if (require('connect')().toString() === app.toString()) {
      return injectConnectApp(app);
    } else {
      return injectHttpServer(app);
    }
  };
  if (opts.attach != null) {
    return inject(opts.attach);
  }
  return _middleware;
};

/*
//@ sourceMappingURL=middleware.map
*/
